
#NoTrayIcon
#Region ; **** Directives Created By AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Lib\img\Logo.ico
#AutoIt3Wrapper_Outfile=Localizer.exe
#AutoIt3Wrapper_UseUpx=N
#AutoIt3Wrapper_Res_Description=Localizer
#AutoIt3Wrapper_Res_Fileversion=1.4.0.0
#AutoIt3Wrapper_Res_ProductVersion=1.4.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Lupo PenSuite Team
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Res_Field=Website|http://dropit.sourceforge.net
#AutoIt3Wrapper_Res_Field=E-Mail|comment at the website
#AutoIt3Wrapper_UseX64=N
#AutoIt3Wrapper_Res_Icon_Add=Lib\img\Copy.ico
#AutoIt3Wrapper_Res_Icon_Add=Lib\img\Google.ico
#AutoIt3Wrapper_Res_Icon_Add=Lib\img\OK.ico
#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6 -w 7
#AutoIt3Wrapper_Run_Obfuscator=Y
#Obfuscator_Parameters=/SF /SV /OM /CF=0 /CN=0 /CS=0 /CV=0
#AutoIt3Wrapper_res_requestedExecutionLevel=asInvoker
#AutoIt3Wrapper_Outfile_Type=exe
#AutoIt3Wrapper_Compile_Both=N
#EndRegion ; **** Directives Created By AutoIt3Wrapper_GUI ****

#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <GUIListView.au3>
#include <GUIToolTip.au3>
#include <IE.au3>
#include <Lib\udf\APIConstants.au3>
#include <Lib\udf\WinAPIEx.au3>
#include <WindowsConstants.au3>

Global $Global_ListView, $Global_ListViewIndex, $Global_DroppedFiles, $Global_Array[1][4], $Global_LanguageDir = @ScriptDir
Global $Global_ResizeWidth = 600, $Global_ResizeHeight = 400, $Global_Version = "1.4"
Global $Global_Languages[55][2] = [ _
		[54, 0], _
		["Afrikaans", "af"], _
		["Albanian", "sq"], _
		["Arabic", "ar"], _
		["Basque", "eu"], _
		["Belarusian", "be"], _
		["Bulgarian", "bg"], _
		["Catalan", "ca"], _
		["Chinese (Simplified)", "zh-CN"], _
		["Chinese (Traditional)", "zh-TW"], _
		["Croatian", "hr"], _
		["Czech", "cs"], _
		["Danish", "da"], _
		["Dutch", "nl"], _
		["English", "en"], _
		["Estonian", "et"], _
		["Filipino", "tl"], _
		["Finnish", "fi"], _
		["French", "fr"], _
		["Galician", "gl"], _
		["Georgian", "ka"], _
		["German", "de"], _
		["Greek", "el"], _
		["Hebrew", "iw"], _
		["Hindi", "hi"], _
		["Hungarian", "hu"], _
		["Icelandic", "is"], _
		["Indonesian", "id"], _
		["Italian", "it"], _
		["Irish", "ga"], _
		["Japanese", "ja"], _
		["Korean", "ko"], _
		["Latvian", "lv"], _
		["Lithuanian", "lt"], _
		["Macedonian", "mk"], _
		["Malay", "ml"], _
		["Maltese", "mt"], _
		["Norwegian", "no"], _
		["Persian", "fa"], _
		["Polish", "pl"], _
		["Portuguese", "pt"], _
		["Romanian", "ro"], _
		["Russian", "ru"], _
		["Serbian", "sr"], _
		["Slovak", "sk"], _
		["Slovenian", "sl"], _
		["Spanish", "es"], _
		["Swahili", "sw"], _
		["Swedish", "sv"], _
		["Thai", "th"], _
		["Turkish", "tr"], _
		["Ukrainian", "uk"], _
		["Vietnamese", "vi"], _
		["Welsh", "cy"], _
		["Yiddish", "yi"]]

_Main()

#Region >>>>> Main Functions <<<<<
Func _Main()
	Local $mGUI, $mMsg, $mListView, $mListView_Handle, $mInput_Find, $mButton_Find, $mButton_Google, $mButton_Copy, $mButton_OK, $mButton_Options, $mButton_Save
	Local $mButton_OldOriginal, $mButton_Original, $mEdit_Original, $mButton_UpdateTranslation, $mEdit_Translation, $mMsgBox
	Local $mOriginalFile, $mTranslationFile, $mOldOriginalFile, $mColumnArray, $mLanguange, $mToolTip, $mText, $mMinimized
	Local $mDropped_Original, $mDropped_UpdateTranslation, $mDropped_OldOriginal, $mFileDropped = 0
	Local $mSelectedFile, $mIndex_Selected, $mNumberLines, $mDeleteLine, $mSaveLine, $mBeforeLine, $mNextLine, $mEsc, $mPreviously_Selected = -1
	Local $mINI = __IsSettingsFile() ; Get Default Settings INI File.
	Local $mOriginalLang = IniRead($mINI, "General", "OriginalLang", "None")
	Local $mTranslationLang = IniRead($mINI, "General", "TranslationLang", "None")
	Local $mMaximized = Number(IniRead($mINI, "General", "Maximized", "0"))
	Local $mSize = __GetCurrentSize("SizeWin") ; 680 x 490.

	$mGUI = GUICreate("Localizer", $mSize[0], $mSize[1], -1, -1, BitOR($GUI_SS_DEFAULT_GUI, $WS_MAXIMIZEBOX, $WS_SIZEBOX), $WS_EX_ACCEPTFILES)

	$mButton_Original = GUICtrlCreateButton("(1) Last English File", 10, 15, 120, 26)
	GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKTOP + $GUI_DOCKLEFT)
	GUICtrlSetTip($mButton_Original, "Select original language file (English recommended)")

	$mButton_UpdateTranslation = GUICtrlCreateButton("(2) Translation File", 10 + 130, 15, 120, 26)
	GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKTOP + $GUI_DOCKLEFT)
	GUICtrlSetTip($mButton_UpdateTranslation, "Select a translation file if you want to update it")

	$mButton_OldOriginal = GUICtrlCreateButton("(3) Old English File", 10 + 260, 15, 120, 26)
	GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKTOP + $GUI_DOCKLEFT)
	GUICtrlSetTip($mButton_OldOriginal, "Select previous original language file to edit only differences")

	$mInput_Find = GUICtrlCreateInput("", $mSize[0] - 10 - 80 - 10 - 110, 17, 110, 22)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER + $GUI_DOCKHEIGHT + $GUI_DOCKTOP + $GUI_DOCKRIGHT)
	GUICtrlSetTip($mInput_Find, "Type a string to search it")
	$mButton_Find = GUICtrlCreateButton("Find Next", $mSize[0] - 10 - 80, 15, 80, 26)
	GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKTOP + $GUI_DOCKRIGHT)

	$mListView = GUICtrlCreateListView("Key|Original|Translation", 10, 58, $mSize[0] - 20, $mSize[1] - 220, BitOR($LVS_NOSORTHEADER, $LVS_REPORT, $LVS_SINGLESEL, $LVS_SHOWSELALWAYS))
	$mListView_Handle = GUICtrlGetHandle($mListView)
	$Global_ListView = $mListView_Handle
	GUICtrlSetResizing($mListView, $GUI_DOCKBORDERS)
	GUICtrlSetState($mListView, $GUI_DROPACCEPTED)

	_GUICtrlListView_SetExtendedListViewStyle($mListView_Handle, BitOR($LVS_EX_FULLROWSELECT, $LVS_EX_GRIDLINES, $LVS_EX_INFOTIP))
	_GUICtrlListView_SetColumnWidth($mListView_Handle, 0, ($mSize[0] - 42) * 1/5)
	_GUICtrlListView_SetColumnWidth($mListView_Handle, 1, ($mSize[0] - 42) * 2/5)
	_GUICtrlListView_SetColumnWidth($mListView_Handle, 2, ($mSize[0] - 42) * 2/5)

	$mToolTip = _GUICtrlListView_GetToolTips($mListView_Handle)
	If IsHWnd($mToolTip) Then
		_GUIToolTip_SetDelayTime($mToolTip, 3, 60) ; Speed Up InfoTip Appearance.
	EndIf

	$mButton_Copy = GUICtrlCreateButton("==>", ($mSize[0] / 2) - 20, $mSize[1] - 145, 40, 24, $BS_ICON)
	GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKBOTTOM + $GUI_DOCKHCENTER)
	GUICtrlSetTip($mButton_Copy, "Copy from original to translation field")
	GUICtrlSetImage($mButton_Copy, @ScriptFullPath, -5, 0)
	$mButton_Google = GUICtrlCreateButton("G", ($mSize[0] / 2) - 20, $mSize[1] - 115, 40, 24, $BS_ICON)
	GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKBOTTOM + $GUI_DOCKHCENTER)
	GUICtrlSetTip($mButton_Google, "Automatically translate original string with Google Translator")
	GUICtrlSetImage($mButton_Google, @ScriptFullPath, -6, 0)
	$mButton_OK = GUICtrlCreateButton("OK", ($mSize[0] / 2) - 20, $mSize[1] - 85, 40, 24, $BS_ICON)
	GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKBOTTOM + $GUI_DOCKHCENTER)
	GUICtrlSetTip($mButton_OK, "Save this translated string (as click ENTER)")
	GUICtrlSetImage($mButton_OK, @ScriptFullPath, -7, 0)

	$mEdit_Original = GUICtrlCreateEdit("", 10, $mSize[1] - 145, ($mSize[0] / 2) - 50, 85, $ES_READONLY + $WS_VSCROLL)
	GUICtrlSetResizing(-1, $GUI_DOCKHEIGHT + $GUI_DOCKBOTTOM + $GUI_DOCKLEFT + $GUI_DOCKHCENTER)
	$mEdit_Translation = GUICtrlCreateEdit("", ($mSize[0] / 2) + 40, $mSize[1] - 145, ($mSize[0] / 2) - 50, 85, $WS_VSCROLL)
	GUICtrlSetResizing(-1, $GUI_DOCKHEIGHT + $GUI_DOCKBOTTOM + $GUI_DOCKRIGHT + $GUI_DOCKHCENTER)

	$mButton_Options = GUICtrlCreateButton("Options", 10, $mSize[1] - 40, 100, 26)
	GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKBOTTOM + $GUI_DOCKLEFT)
	$mButton_Save = GUICtrlCreateButton("Save Translation File", ($mSize[0] / 2) - 110, $mSize[1] - 39, 220, 28)
	GUICtrlSetResizing(-1, $GUI_DOCKSIZE + $GUI_DOCKBOTTOM + $GUI_DOCKHCENTER)

	GUICtrlSetState($mButton_UpdateTranslation, $GUI_DISABLE)
	GUICtrlSetState($mButton_OldOriginal, $GUI_DISABLE)
	GUICtrlSetState($mInput_Find, $GUI_DISABLE)
	GUICtrlSetState($mButton_Find, $GUI_DISABLE)
	GUICtrlSetState($mListView, $GUI_DISABLE)
	GUICtrlSetState($mEdit_Original, $GUI_DISABLE)
	GUICtrlSetState($mEdit_Translation, $GUI_DISABLE)
	GUICtrlSetState($mButton_Google, $GUI_DISABLE)
	GUICtrlSetState($mButton_Copy, $GUI_DISABLE)
	GUICtrlSetState($mButton_OK, $GUI_DISABLE)
	GUICtrlSetState($mButton_Save, $GUI_DISABLE)

	$Global_ListViewIndex = -1 ; Set As No Item Selected.
	GUIRegisterMsg($WM_DROPFILES, "_WM_DROPFILES")
	GUIRegisterMsg($WM_GETMINMAXINFO, "_WM_GETMINMAXINFO")
	GUIRegisterMsg($WM_NOTIFY, "_WM_NOTIFY")
	GUIRegisterMsg($WM_SIZE, "_WM_SIZE")
	GUISetState(@SW_SHOW)
	If $mMaximized Then
		GUISetState(@SW_MAXIMIZE, $mGUI)
	EndIf

	$mDropped_Original = GUICtrlCreateDummy()
	$mDropped_UpdateTranslation = GUICtrlCreateDummy()
	$mDropped_OldOriginal = GUICtrlCreateDummy()

	$mDeleteLine = GUICtrlCreateDummy()
	$mBeforeLine = GUICtrlCreateDummy()
	$mNextLine = GUICtrlCreateDummy()
	$mSaveLine = GUICtrlCreateDummy()
	$mEsc = GUICtrlCreateDummy()
	Local $mHotKeys[7][2] = [["^d", $mDeleteLine],["{UP}", $mBeforeLine],["+{ENTER}", $mBeforeLine],["{DOWN}", $mNextLine],["{TAB}", $mNextLine],["{ENTER}", $mSaveLine],["{ESC}", $mEsc]]
	GUISetAccelerators($mHotKeys)

	If __Is("RestoreFiles") Then
		$mSelectedFile = IniRead($mINI, "General", "OriginalFile", "None") ; Restore Original.
		If $mSelectedFile <> "None" Then
			$mLanguange = __GetFileNameOnly($mSelectedFile)
			$mNumberLines = _Load_Original($mListView_Handle, $mSelectedFile, $mLanguange)
			If @error Then
				__IniWriteEx($mINI, "General", "OriginalFile", "None")
				__IniWriteEx($mINI, "General", "TranslationFile", "None")
				__IniWriteEx($mINI, "General", "OldOriginalFile", "None")
			Else
				_GUICtrlListView_SetColumn($mListView_Handle, 1, "Original (" & $mLanguange & ")")
				GUICtrlSetState($mButton_UpdateTranslation, $GUI_ENABLE)
				GUICtrlSetState($mButton_OldOriginal, $GUI_ENABLE)
				GUICtrlSetState($mInput_Find, $GUI_ENABLE)
				GUICtrlSetState($mButton_Find, $GUI_ENABLE)
				GUICtrlSetState($mListView, $GUI_ENABLE)
				GUICtrlSetState($mEdit_Original, $GUI_ENABLE)
				GUICtrlSetState($mEdit_Translation, $GUI_ENABLE)
				GUICtrlSetState($mButton_Google, $GUI_ENABLE)
				GUICtrlSetState($mButton_Copy, $GUI_ENABLE)
				GUICtrlSetState($mButton_OK, $GUI_ENABLE)
				GUICtrlSetState($mButton_Save, $GUI_ENABLE)
				$Global_LanguageDir = __GetParentFolder($mSelectedFile)
				$mOriginalFile = $mSelectedFile
				$mFileDropped = 1 ; To Correctly Support Drag&Drop.

				$mSelectedFile = IniRead($mINI, "General", "TranslationFile", "None") ; Restore Translation.
				If $mSelectedFile <> "None" Then
					$mLanguange = __GetFileNameOnly($mSelectedFile)
					_Load_Translation($mListView_Handle, $mSelectedFile, $mLanguange)
					If @error Then
						__IniWriteEx($mINI, "General", "TranslationFile", "None")
						__IniWriteEx($mINI, "General", "OldOriginalFile", "None")
					Else
						_GUICtrlListView_SetColumn($mListView_Handle, 2, "Translation (" & $mLanguange & ")")
						$Global_LanguageDir = __GetParentFolder($mSelectedFile)
						$mTranslationFile = $mSelectedFile
						$mFileDropped = 2 ; To Correctly Support Drag&Drop.
					EndIf
				EndIf

				$mSelectedFile = IniRead($mINI, "General", "OldOriginalFile", "None") ; Restore Previous Original.
				$mLanguange = __GetFileNameOnly($mSelectedFile)
				$mColumnArray = _GUICtrlListView_GetColumn($mListView_Handle, 1)
				If $mColumnArray[5] <> "Original (" & $mLanguange & ")" Then
					__IniWriteEx($mINI, "General", "OldOriginalFile", "None")
				Else
					$mNumberLines = _Load_OldOriginal($mListView_Handle, $mSelectedFile, $mLanguange)
					If @error Then
						__IniWriteEx($mINI, "General", "OldOriginalFile", "None")
					Else
						GUICtrlSetState($mButton_UpdateTranslation, $GUI_DISABLE)
						GUICtrlSetState($mButton_OldOriginal, $GUI_DISABLE)
						$mOldOriginalFile = $mSelectedFile
						$mFileDropped = 0 ; To Correctly Support Drag&Drop.
					EndIf
				EndIf

				$Global_ListViewIndex = Number(IniRead($mINI, "General", "LastLine", "0")) ; Restore Last Selected Line.
				If $Global_ListViewIndex >= $mNumberLines Then
					$Global_ListViewIndex = 0
				EndIf
				_GUICtrlListView_SetItemSelected($mListView_Handle, $Global_ListViewIndex)
				_GUICtrlListView_SetItemFocused($mListView_Handle, $Global_ListViewIndex)
				_GUICtrlListView_EnsureVisible($mListView_Handle, $Global_ListViewIndex)
			EndIf
		EndIf
	EndIf

	While 1
		$mIndex_Selected = $Global_ListViewIndex
		If $mPreviously_Selected <> $mIndex_Selected Then
			$mPreviously_Selected = $mIndex_Selected
			$mText = _GUICtrlListView_GetItemText($mListView_Handle, $mIndex_Selected, 1)
			GUICtrlSetData($mEdit_Original, $mText)
			$mText = _GUICtrlListView_GetItemText($mListView_Handle, $mIndex_Selected, 2)
			GUICtrlSetData($mEdit_Translation, $mText)
		EndIf

		$mMsg = GUIGetMsg()
		Switch $mMsg
			Case $GUI_EVENT_CLOSE, $mEsc
				$mMsgBox = MsgBox(0x4, "Close the Localizer", "Are you sure to close the Localizer now?")
				If $mMsgBox = 6 Then
					ExitLoop
				EndIf

			Case $GUI_EVENT_MAXIMIZE
				If $mMaximized = 0 Then
					$mMaximized = 1
				EndIf

			Case $GUI_EVENT_MINIMIZE
				If $mMinimized = 0 Then
					$mMinimized = 1
				EndIf

			Case $GUI_EVENT_RESTORE
				If $mMaximized And $mMinimized = 0 Then
					$mMaximized = 0
					WinMove($mGUI, "", (@DesktopWidth / 2) - (680 / 2), (@DesktopHeight / 2) - (490 / 2), 680, 490) ; Restore Original Size.
				EndIf
				$mMinimized = 0

			Case $GUI_EVENT_DROPPED
				If $Global_DroppedFiles[0] = 0 Then
					ContinueLoop
				EndIf
				Switch $mFileDropped
					Case 0
						GUICtrlSendToDummy($mDropped_Original)
					Case 1
						GUICtrlSendToDummy($mDropped_UpdateTranslation)
					Case 2
						GUICtrlSendToDummy($mDropped_OldOriginal)
				EndSwitch

			Case $mButton_Original, $mDropped_Original
				If $mMsg = $mDropped_Original Then
					$mSelectedFile = $Global_DroppedFiles[1]
				Else
					$mSelectedFile = FileOpenDialog("Select original language file", $Global_LanguageDir, "Language files (*.lng)|INI files (*.ini)", 1, "", $mGUI)
					If @error Then
						ContinueLoop
					EndIf
				EndIf
				$mTranslationFile = ""
				GUICtrlSetData($mEdit_Original, "")
				GUICtrlSetData($mEdit_Translation, "")
				_GUICtrlListView_SetColumn($mListView_Handle, 2, "Translation")
				$mLanguange = __GetFileNameOnly($mSelectedFile)
				$mNumberLines = _Load_Original($mListView_Handle, $mSelectedFile, $mLanguange)
				If @error Then
					MsgBox(0x30, "Broken Language File", "The selected language file is broken. Try to load another file.")
					ContinueLoop
				EndIf
				_GUICtrlListView_SetColumn($mListView_Handle, 1, "Original (" & $mLanguange & ")")
				GUICtrlSetState($mButton_UpdateTranslation, $GUI_ENABLE)
				GUICtrlSetState($mButton_OldOriginal, $GUI_ENABLE)
				GUICtrlSetState($mInput_Find, $GUI_ENABLE)
				GUICtrlSetState($mButton_Find, $GUI_ENABLE)
				GUICtrlSetState($mListView, $GUI_ENABLE)
				GUICtrlSetState($mEdit_Original, $GUI_ENABLE)
				GUICtrlSetState($mEdit_Translation, $GUI_ENABLE)
				GUICtrlSetState($mButton_Google, $GUI_ENABLE)
				GUICtrlSetState($mButton_Copy, $GUI_ENABLE)
				GUICtrlSetState($mButton_OK, $GUI_ENABLE)
				GUICtrlSetState($mButton_Save, $GUI_ENABLE)
				$Global_LanguageDir = __GetParentFolder($mSelectedFile)
				$mOriginalFile = $mSelectedFile
				$mFileDropped = 1 ; To Correctly Support Drag&Drop.
				For $A = 1 To $Global_Languages[0][0]
					If StringInStr($mLanguange, $Global_Languages[$A][0]) Then
						__IniWriteEx($mINI, "General", "OriginalLang", $Global_Languages[$A][1])
					EndIf
				Next

			Case $mButton_UpdateTranslation, $mDropped_UpdateTranslation
				If $mMsg = $mDropped_UpdateTranslation Then
					$mSelectedFile = $Global_DroppedFiles[1]
				Else
					$mSelectedFile = FileOpenDialog("Select your translation file", $Global_LanguageDir, "Language file (*.lng)|INI files (*.ini)", 1, "", $mGUI)
					If @error Then
						ContinueLoop
					EndIf
				EndIf
				$mLanguange = __GetFileNameOnly($mSelectedFile)
				_Load_Translation($mListView_Handle, $mSelectedFile, $mLanguange)
				If @error Then
					MsgBox(0x30, "Broken Language File", "The selected language file is broken. Try to load another file or create a new one.")
					ContinueLoop
				EndIf
				_GUICtrlListView_SetColumn($mListView_Handle, 2, "Translation (" & $mLanguange & ")")
				$Global_LanguageDir = __GetParentFolder($mSelectedFile)
				$mTranslationFile = $mSelectedFile
				$mFileDropped = 2 ; To Correctly Support Drag&Drop.
				For $A = 1 To $Global_Languages[0][0]
					If StringInStr($mLanguange, $Global_Languages[$A][0]) Then
						__IniWriteEx($mINI, "General", "TranslationLang", $Global_Languages[$A][1])
					EndIf
				Next

			Case $mButton_OldOriginal, $mDropped_OldOriginal
				If $mMsg = $mDropped_OldOriginal Then
					$mSelectedFile = $Global_DroppedFiles[1]
				Else
					$mSelectedFile = FileOpenDialog("Select previous original language file", @ScriptDir, "Language file (*.lng)|INI files (*.ini)", 1, "", $mGUI)
					If @error Then
						ContinueLoop
					EndIf
				EndIf
				$mLanguange = __GetFileNameOnly($mSelectedFile)
				$mColumnArray = _GUICtrlListView_GetColumn($mListView_Handle, 1)
				If $mColumnArray[5] <> "Original (" & $mLanguange & ")" Then
					MsgBox(0x30, "Wrong Language File", "The selected file is different from the original language.")
					ContinueLoop
				EndIf
				$mNumberLines = _Load_OldOriginal($mListView_Handle, $mSelectedFile, $mLanguange)
				If @error Then
					MsgBox(0x30, "Broken Language File", "The selected language file is broken. Try to load another file.")
					ContinueLoop
				EndIf
				GUICtrlSetState($mButton_UpdateTranslation, $GUI_DISABLE)
				GUICtrlSetState($mButton_OldOriginal, $GUI_DISABLE)
				$Global_ListViewIndex = -1 ; Set As No Item Selected.
				$mOldOriginalFile = $mSelectedFile
				$mFileDropped = 0 ; To Correctly Support Drag&Drop.

			Case $mBeforeLine
				$Global_ListViewIndex -= 1
				If $Global_ListViewIndex = -1 Then
					$Global_ListViewIndex = $mNumberLines - 1
				EndIf
				_GUICtrlListView_SetItemSelected($mListView_Handle, $Global_ListViewIndex)
				_GUICtrlListView_SetItemFocused($mListView_Handle, $Global_ListViewIndex)
				_GUICtrlListView_EnsureVisible($mListView_Handle, $Global_ListViewIndex)

			Case $mNextLine, $mSaveLine, $mButton_OK
				$Global_ListViewIndex += 1
				If $Global_ListViewIndex = $mNumberLines Then
					$Global_ListViewIndex = 0
				EndIf
				If $mMsg <> $mNextLine Then
					$mText = GUICtrlRead($mEdit_Translation)
					_GUICtrlListView_SetItemText($mListView_Handle, $mPreviously_Selected, $mText, 2)
				EndIf
				_GUICtrlListView_SetItemSelected($mListView_Handle, $Global_ListViewIndex)
				_GUICtrlListView_SetItemFocused($mListView_Handle, $Global_ListViewIndex)
				_GUICtrlListView_EnsureVisible($mListView_Handle, $Global_ListViewIndex)

			Case $mDeleteLine
				GUICtrlSetData($mEdit_Translation, "")

			Case $mButton_Google
				If GUICtrlRead($mEdit_Original) <> "" Then
					If $mOriginalLang = "None" Then
						MsgBox(0x40, "Select Languages", "You need to select original and translation languages to use this feature.")
						_Options($mGUI)
						If @error Then
							ContinueLoop
						EndIf
						$mOriginalLang = IniRead($mINI, "General", "OriginalLang", "None")
						$mTranslationLang = IniRead($mINI, "General", "TranslationLang", "None")
					EndIf
					GUICtrlSetState($mEdit_Translation, $GUI_DISABLE)
					For $A = 1 To 5
						$mText = __GetTranslate(GUICtrlRead($mEdit_Original), $mOriginalLang, $mTranslationLang)
						GUICtrlSetData($mEdit_Translation, $mText)
						If GUICtrlRead($mEdit_Translation) <> "0" Then
							ExitLoop
						EndIf
					Next
					If GUICtrlRead($mEdit_Translation) = "0" Then
						MsgBox(0x30, "Error", "Automatic translation failed. Try again later.")
					EndIf
					GUICtrlSetState($mEdit_Translation, $GUI_ENABLE)
				EndIf

			Case $mButton_Copy
				$mText = GUICtrlRead($mEdit_Original)
				If $mText <> "" Then
					GUICtrlSetData($mEdit_Translation, $mText)
				EndIf

			Case $mButton_Find
				$mText = GUICtrlRead($mInput_Find)
				If $mText <> "" Then
					$Global_ListViewIndex = _Find_String($mListView_Handle, $mText, $mNumberLines, $Global_ListViewIndex)
				Else
					MsgBox(0, "Empty Input Field", "The input field on the left of this button is empty." & @LF & "Type a string to search it.")
				EndIf

			Case $mButton_Options
				_Options($mGUI)
				If @error Then
					ContinueLoop
				EndIf
				$mOriginalLang = IniRead($mINI, "General", "OriginalLang", "None")
				$mTranslationLang = IniRead($mINI, "General", "TranslationLang", "None")

			Case $mButton_Save
				$mSelectedFile = _Save_Translation($mListView_Handle, $mOriginalFile, $mTranslationFile, $mGUI)
				If @error Then
					ContinueLoop
				EndIf
				If __Is("KeepBackup") Then
					MsgBox(0, "Translation Saved", "The updated translation is saved and a backup of the previous translation is created!")
				Else
					MsgBox(0, "Translation Saved", "The updated translation is saved!")
				EndIf
				$mTranslationFile = $mSelectedFile
				$mLanguange = __GetFileNameOnly($mTranslationFile)
				_GUICtrlListView_SetColumn($mListView_Handle, 2, "Translation (" & $mLanguange & ")")

		EndSwitch
	WEnd

	__SetCurrentSize($mGUI, "SizeWin")
	__IniWriteEx($mINI, "General", "Maximized", $mMaximized)
	If __Is("RestoreFiles") = 0 Then
		$mOriginalFile = "None"
		$mTranslationFile = "None"
		$mOldOriginalFile = "None"
		$Global_ListViewIndex = 0
	EndIf
	__IniWriteEx($mINI, "General", "OriginalFile", $mOriginalFile)
	__IniWriteEx($mINI, "General", "TranslationFile", $mTranslationFile)
	__IniWriteEx($mINI, "General", "OldOriginalFile", $mOldOriginalFile)
	__IniWriteEx($mINI, "General", "LastLine", $Global_ListViewIndex)
EndFunc   ;==>_Main

Func _Load_Original($oListView_Handle, $oLanguageFile, $oLanguange)
	Local $oArray = __IniReadSection($oLanguageFile, $oLanguange)
	If @error Then
		Return SetError(1, 0, 0)
	EndIf
	ReDim $Global_Array[$oArray[0][0] + 1][4]
	$Global_Array[0][0] = $oArray[0][0]

	_GUICtrlListView_DeleteAllItems($oListView_Handle)
	For $A = 1 To $oArray[0][0]
		$Global_Array[$A][0] = $oArray[$A][0] ; Key.
		$Global_Array[$A][1] = $oArray[$A][1] ; Original String.
		$Global_Array[$A][2] = "" ; Clean Translation String.
		$Global_Array[$A][3] = $A ; Visible Original String.
		_GUICtrlListView_AddItem($oListView_Handle, $oArray[$A][0], $A - 1)
		_GUICtrlListView_AddSubItem($oListView_Handle, $A - 1, $oArray[$A][1], 1)
	Next

	Return $oArray[0][0]
EndFunc   ;==>_Load_Original

Func _Load_OldOriginal($oListView_Handle, $oLanguageFile, $oLanguange)
	Local $oKey, $oCounter
	Local $oArray = __IniReadSection($oLanguageFile, $oLanguange)
	If @error Then
		Return SetError(1, 0, 0)
	EndIf

	_GUICtrlListView_DeleteAllItems($oListView_Handle)
	For $A = 1 To $Global_Array[0][0]
		$oKey = $Global_Array[$A][0]
		For $B = 1 To $oArray[0][0]
			If $oKey = $oArray[$B][0] Then
				If $Global_Array[$A][1] = $oArray[$B][1] Then
					$Global_Array[$A][3] = 0 ; Hidden Original String.
				EndIf
				ExitLoop
			EndIf
		Next
		If $Global_Array[$A][3] <> 0 Then
			$oCounter += 1
			$Global_Array[$A][3] = $oCounter ; ListView Index.
			_GUICtrlListView_AddItem($oListView_Handle, $oKey, $oCounter - 1)
			_GUICtrlListView_AddSubItem($oListView_Handle, $oCounter - 1, $Global_Array[$A][1], 1)
			_GUICtrlListView_AddSubItem($oListView_Handle, $oCounter - 1, $Global_Array[$A][2], 2)
		EndIf
	Next

	Return $oCounter
EndFunc   ;==>_Load_OldOriginal

Func _Load_Translation($oListView_Handle, $oLanguageFile, $oLanguange)
	Local $oKey
	Local $oArray = __IniReadSection($oLanguageFile, $oLanguange)
	If @error Then
		Return SetError(1, 0, 0)
	EndIf

	For $A = 1 To $Global_Array[0][0]
		$oKey = $Global_Array[$A][0]
		For $B = 1 To $oArray[0][0]
			If $oKey = $oArray[$B][0] Then
				$Global_Array[$A][2] = $oArray[$B][1] ; Translation String.
				If $Global_Array[$A][3] <> 0 Then
					_GUICtrlListView_AddSubItem($oListView_Handle, $Global_Array[$A][3] - 1, $oArray[$B][1], 2)
				EndIf
				ExitLoop
			EndIf
		Next
	Next
EndFunc   ;==>_Load_Translation

Func _Save_Translation($oListView_Handle, $oOriginalFile, $oLanguageFile, $oMainGUI)
	Local $oFileOpen, $oFileLine, $oName, $oContact, $oURL, $oLanguange, $oKey, $oValue, $oEncoding = 0

	If FileExists($oLanguageFile) Then
		$oFileOpen = FileOpen($oLanguageFile, 0)
		If $oFileOpen = -1 Then
			MsgBox(0x30, "Error", "Unable to read the header of the language file.")
			Exit
		EndIf
		For $A = 1 To 5
			$oFileLine = FileReadLine($oFileOpen)
			If StringInStr($oFileLine, "TranslatorName") Then
				$oName = StringTrimLeft($oFileLine, 16)
			ElseIf StringInStr($oFileLine, "TranslatorContact") Then
				$oContact = StringTrimLeft($oFileLine, 19)
			ElseIf StringInStr($oFileLine, "TranslatorURL") Then
				$oURL = StringTrimLeft($oFileLine, 15)
			EndIf
		Next
		FileClose($oFileOpen)
		$oEncoding = FileGetEncoding($oLanguageFile)
	Else
		$oLanguageFile = __GetParentFolder($oOriginalFile) & "\YourLanguage." & __GetFileExtension($oOriginalFile)
	EndIf

	$oLanguageFile = _Create_TranslationHeader($oLanguageFile, $oEncoding, $oName, $oContact, $oURL, $oMainGUI)
	If @error Then
		Return SetError(1, 0, $oLanguageFile)
	EndIf
	$oLanguange = __GetFileNameOnly($oLanguageFile)

	For $A = 1 To $Global_Array[0][0]
		$oKey = $Global_Array[$A][0]
		If $Global_Array[$A][3] <> 0 Then
			$oValue = _GUICtrlListView_GetItemText($oListView_Handle, $Global_Array[$A][3] - 1, 2)
			If $oValue = "" Then
				;$oValue = _GUICtrlListView_GetItemText($oListView_Handle, $Global_Array[$A][3] - 1, 1) ; Use Original Language If Translation Is Empty.
				ContinueLoop
			EndIf
		Else
			$oValue = $Global_Array[$A][2]
			If $oValue = "" Then
				;$oValue = $Global_Array[$A][1] ; Use Original Language If Translation Is Empty.
				ContinueLoop
			EndIf
		EndIf
		__IniWriteEx($oLanguageFile, $oLanguange, $oKey, $oValue)
	Next

	Return $oLanguageFile
EndFunc   ;==>_Save_Translation

Func _Create_TranslationHeader($oLanguageFile, $oEncoding, $oName, $oContact, $oURL, $oMainGUI)
	Local $oGUI, $oSave, $oCancel, $oFileOpen, $oError = 0, $oLanguange = __GetFileNameOnly($oLanguageFile)
	Local $oInput_Name, $oInput_Contact, $oInput_URL, $oInput_Language, $oCombo_Encoding, $oString_Encoding

	Switch $oEncoding
		Case 32
			$oString_Encoding = "UTF16 Little Endian"
		Case 64
			$oString_Encoding = "UTF16 Big Endian"
		Case 128
			$oString_Encoding = "UTF8 (with BOM)"
		Case 256
			$oString_Encoding = "UTF8 (without BOM)"
		Case Else
			$oString_Encoding = "ANSI"
	EndSwitch

	$oGUI = GUICreate("Save Translation", 300, 360, -1, -1, -1, $WS_EX_TOOLWINDOW, $oMainGUI)
	GUICtrlCreateLabel("Language:", 15, 10, 260, 20)
	$oInput_Language = GUICtrlCreateInput($oLanguange, 10, 10 + 20, 280, 22)
	GUICtrlCreateLabel("Encoding:", 15, 10 + 60, 260, 20)
	$oCombo_Encoding = GUICtrlCreateCombo("", 10, 10 + 20 + 60, 280, 22, $WS_VSCROLL + $CBS_DROPDOWNLIST)
	GUICtrlSetData(-1, "ANSI|UTF16 Little Endian|UTF16 Big Endian|UTF8 (with BOM)|UTF8 (without BOM)", $oString_Encoding)
	GUICtrlCreateLabel("Your Name:", 15, 10 + 120, 260, 20)
	$oInput_Name = GUICtrlCreateInput($oName, 10, 10 + 20 + 120, 280, 22)
	GUICtrlSetTip($oInput_Name, "Your name or nickname (if you want)")
	GUICtrlCreateLabel("Your Contact:", 15, 10 + 180, 260, 20)
	$oInput_Contact = GUICtrlCreateInput($oContact, 10, 10 + 20 + 180, 280, 22)
	GUICtrlSetTip($oInput_Contact, "Your email or contact page (if you want)")
	GUICtrlCreateLabel("Your URL:", 15, 10 + 240, 260, 20)
	$oInput_URL = GUICtrlCreateInput($oURL, 10, 10 + 20 + 240, 280, 22)
	GUICtrlSetTip($oInput_URL, "Your website or blog (if you want)")

	$oSave = GUICtrlCreateButton("Save", 150 - 30 - 85, 315, 85, 26)
	$oCancel = GUICtrlCreateButton("Cancel", 150 + 30, 315, 85, 26)
	GUICtrlSetState($oSave, $GUI_DEFBUTTON)
	GUISetState(@SW_SHOW)

	While 1
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE, $oCancel
				$oError = 1
				ExitLoop

			Case $oSave
				$oLanguange = GUICtrlRead($oInput_Language)
				If $oLanguange == "" Then
					MsgBox(0x30, "Error", "The language field is empty.")
					ContinueLoop
				EndIf
				$oLanguageFile = __GetParentFolder($oLanguageFile) & "\" & $oLanguange & "." & __GetFileExtension($oLanguageFile)
				Switch GUICtrlRead($oCombo_Encoding)
					Case "UTF16 Little Endian"
						$oEncoding = 32
					Case "UTF16 Big Endian"
						$oEncoding = 64
					Case "UTF8 (with BOM)"
						$oEncoding = 128
					Case "UTF8 (without BOM)"
						$oEncoding = 256
					Case Else
						$oEncoding = 0
				EndSwitch
				If FileExists($oLanguageFile) And __Is("KeepBackup") Then
					FileMove($oLanguageFile, $oLanguageFile & ".bak", 9)
				EndIf
				$oFileOpen = FileOpen($oLanguageFile, 2 + 8 + $oEncoding)
				If $oFileOpen = -1 Then
					MsgBox(0x30, "Error", "Unable to create the language file.")
					$oError = 1
					ExitLoop
				EndIf
				FileWrite($oFileOpen, ";Language=" & $oLanguange & @CRLF)
				FileWrite($oFileOpen, ";TranslatorName=" & GUICtrlRead($oInput_Name) & @CRLF)
				FileWrite($oFileOpen, ";TranslatorContact=" & GUICtrlRead($oInput_Contact) & @CRLF)
				FileWrite($oFileOpen, ";TranslatorURL=" & GUICtrlRead($oInput_URL) & @CRLF)
				FileWrite($oFileOpen, ";LastUpdated=" & @MDAY & "/" & @MON & "/" & @YEAR & @CRLF & @CRLF)
				FileClose($oFileOpen)
				ExitLoop

		EndSwitch
	WEnd
	GUIDelete($oGUI)

	If $oError = 1 Then
		Return SetError(1, 0, $oLanguageFile)
	EndIf
	Return $oLanguageFile
EndFunc   ;==>_Create_TranslationHeader

Func _Options($sMainGUI)
	Local $sGUI, $sOK, $sCancel, $sCombo_Original, $sCombo_Translation, $sCheckbox_Restore, $sCheckbox_Backup, $sState
	Local $sOriginalSelected, $sTranslationSelected, $sString, $sError = 0
	Local $sINI = __IsSettingsFile() ; Get Default Settings INI File.
	Local $sOriginalLang = IniRead($sINI, "General", "OriginalLang", "None")
	Local $sTranslationLang = IniRead($sINI, "General", "TranslationLang", "None")

	$sGUI = GUICreate("Options", 320, 215, -1, -1, -1, $WS_EX_TOOLWINDOW, $sMainGUI)

	GUICtrlCreateGroup("General Settings", 10, 10, 300, 65)
	$sCheckbox_Restore = GUICtrlCreateCheckbox("Restore the previous session at startup", 25, 10 + 18, 270, 20)
	$sCheckbox_Backup = GUICtrlCreateCheckbox("Keep the backup of the translation file", 25, 10 + 18 + 20, 270, 20)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("Google Translator Languages", 10, 10 + 70, 300, 85)
	GUICtrlCreateLabel("Original:", 25, 10 + 70 + 20 + 3, 80, 20)
	$sCombo_Original = GUICtrlCreateCombo("", 25 + 85, 10 + 70 + 20, 190, 22, $WS_VSCROLL + $CBS_DROPDOWNLIST)
	GUICtrlCreateLabel("Translation:", 25, 10 + 70 + 50 + 3, 80, 20)
	$sCombo_Translation = GUICtrlCreateCombo("", 25 + 85, 10 + 70 + 50, 190, 22, $WS_VSCROLL + $CBS_DROPDOWNLIST)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	$sOK = GUICtrlCreateButton("OK", 160 - 25 - 90, 177, 90, 26)
	$sCancel = GUICtrlCreateButton("Cancel", 160 + 25, 177, 90, 26)

	If __Is("RestoreFiles") Then
		GUICtrlSetState($sCheckbox_Restore, $GUI_CHECKED)
	EndIf
	If __Is("KeepBackup") Then
		GUICtrlSetState($sCheckbox_Backup, $GUI_CHECKED)
	EndIf
	If $sOriginalLang = "None" Then
		$sOriginalLang = "en"
	EndIf
	If $sTranslationLang = "None" Then
		$sTranslationLang = "en"
	EndIf
	For $A = 1 To $Global_Languages[0][0]
		$sString &= $Global_Languages[$A][0] & "|"
		If $sOriginalLang = $Global_Languages[$A][1] Then
			$sOriginalSelected = $Global_Languages[$A][0]
		EndIf
		If $sTranslationLang = $Global_Languages[$A][1] Then
			$sTranslationSelected = $Global_Languages[$A][0]
		EndIf
	Next
	$sString = StringTrimRight($sString, 1)
	GUICtrlSetData($sCombo_Original, $sString, $sOriginalSelected)
	GUICtrlSetData($sCombo_Translation, $sString, $sTranslationSelected)

	GUICtrlSetState($sOK, $GUI_DEFBUTTON)
	GUISetState(@SW_SHOW)

	While 1
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE, $sCancel
				$sError = 1
				ExitLoop

			Case $sOK
				$sState = "False"
				If GUICtrlRead($sCheckbox_Restore) = 1 Then
					$sState = "True"
				EndIf
				__IniWriteEx($sINI, "General", "RestoreFiles", $sState)

				$sState = "False"
				If GUICtrlRead($sCheckbox_Backup) = 1 Then
					$sState = "True"
				EndIf
				__IniWriteEx($sINI, "General", "KeepBackup", $sState)

				$sOriginalSelected = GUICtrlRead($sCombo_Original)
				For $A = 1 To $Global_Languages[0][0]
					If $sOriginalSelected = $Global_Languages[$A][0] Then
						__IniWriteEx($sINI, "General", "OriginalLang", $Global_Languages[$A][1])
					EndIf
				Next

				$sTranslationSelected = GUICtrlRead($sCombo_Translation)
				For $A = 1 To $Global_Languages[0][0]
					If $sTranslationSelected = $Global_Languages[$A][0] Then
						__IniWriteEx($sINI, "General", "TranslationLang", $Global_Languages[$A][1])
					EndIf
				Next
				ExitLoop

		EndSwitch
	WEnd
	GUIDelete($sGUI)

	If $sError = 1 Then
		Return SetError(1, 0, 0)
	EndIf
	Return 1
EndFunc   ;==>_Options

Func _Find_String($fListView_Handle, $fString, $fNumberLines, $fIndex_Selected)
	Local $fOriginal, $fTranslation
	If $fString <> "" Then
		For $A = 1 To $fNumberLines
			$fIndex_Selected += 1
			If $fIndex_Selected = $fNumberLines Then
				$fIndex_Selected = 0 ; Return To The First Line.
			EndIf
			$fOriginal = _GUICtrlListView_GetItemText($fListView_Handle, $fIndex_Selected, 1)
			$fTranslation = _GUICtrlListView_GetItemText($fListView_Handle, $fIndex_Selected, 2)
			If StringInStr($fOriginal, $fString) Or StringInStr($fTranslation, $fString) Then
				_GUICtrlListView_SetItemSelected($fListView_Handle, $fIndex_Selected)
				_GUICtrlListView_SetItemFocused($fListView_Handle, $fIndex_Selected)
				_GUICtrlListView_EnsureVisible($fListView_Handle, $fIndex_Selected)
				Return $fIndex_Selected
			EndIf
		Next
		MsgBox(0, "Not found", "Can't find the text:" & @LF & $fString)
	EndIf
	Return SetError(1, 0, 0)
EndFunc   ;==>_Find_String
#EndRegion >>>>> Main Functions <<<<<

#Region >>>>> WM Functions <<<<<
Func _WM_DROPFILES($hWnd, $iMsg, $iwParam, $ilParam)
	#forceref $hWnd, $iMsg, $ilParam
	Local $aError[1] = [0]
	Switch $iMsg
		Case $WM_DROPFILES
			Local $aReturn = _WinAPI_DragQueryFileEx($iwParam)
			If IsArray($aReturn) Then
				$Global_DroppedFiles = $aReturn
			Else
				$Global_DroppedFiles = $aError
			EndIf
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_DROPFILES

Func _WM_GETMINMAXINFO($hWnd, $iMsg, $iwParam, $ilParam) ; Enable The GUI From Being Dragged To A Certain Size.
	#forceref $hWnd, $iMsg, $iwParam
	Local $gStructure = DllStructCreate("int;int;int;int;int;int;int;int;int;int", $ilParam)
	DllStructSetData($gStructure, 7, $Global_ResizeWidth) ; Min Width.
	DllStructSetData($gStructure, 8, $Global_ResizeHeight) ; Min Height.
	DllStructSetData($gStructure, 9, @DesktopWidth) ; Max Width.
	DllStructSetData($gStructure, 10, @DesktopHeight) ; Max Height.
	Return 0
EndFunc   ;==>_WM_GETMINMAXINFO

Func _WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
	#forceref $hWnd, $iMsg, $iwParam
	Local $nListView = $Global_ListView
	If IsHWnd($nListView) = 0 Then
		$nListView = GUICtrlGetHandle($nListView)
	EndIf
	Local $tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
	Local $nWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
	Local $nCode = DllStructGetData($tNMHDR, "Code")
	Local $nInfo = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
	Local $nIndex = DllStructGetData($nInfo, "Index")
	Switch $nWndFrom
		Case $nListView
			Switch $nCode
				Case $NM_CLICK
					$Global_ListViewIndex = $nIndex
				Case $NM_DBLCLK
					$Global_ListViewIndex = $nIndex
				Case $NM_RCLICK
					$Global_ListViewIndex = $nIndex
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_NOTIFY

Func _WM_SIZE($hWnd, $iMsg, $iwParam, $lParam)
	#forceref $hWnd, $iMsg, $iwParam
	Local $iWidth = BitAND($lParam, 0xFFFF)
	_GUICtrlListView_SetColumnWidth($Global_ListView, 0, ($iWidth - 42) * 1/5)
	_GUICtrlListView_SetColumnWidth($Global_ListView, 1, ($iWidth - 42) * 2/5)
	_GUICtrlListView_SetColumnWidth($Global_ListView, 2, ($iWidth - 42) * 2/5)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_SIZE
#EndRegion >>>>> WM Functions <<<<<

#Region >>>>> Setting Functions <<<<<
Func __Is($iData, $iINI = -1, $iDefault = "False")
	#cs
		Description: For INI Parameters That Use True/False Results, Therefore It Can Be Called As If __Is("DropItOn") Then ... , Simply Means If DropItOn Is True.
		Returns: True/False
	#ce
	If $iINI = -1 Then
		$iINI = __IsSettingsFile() ; Get Default Settings INI File.
	EndIf
	Return IniRead($iINI, "General", $iData, $iDefault) = "True"
EndFunc   ;==>__Is

Func __IsSettingsFile($iINI = -1)
	#cs
		Description: Provide A Valid Location Of The Settings INI File.
		Returns: Settings INI File [C:\Program Files\DropIt\Settings.ini]
	#ce
	Local $iFileExists, $iFileGetSize, $iINIData

	If $iINI = -1 Then
		$iINI = @ScriptDir & "\settings.ini"
	EndIf
	$iFileExists = FileExists($iINI)
	$iFileGetSize = FileGetSize($iINI)

	If $iFileExists And $iFileGetSize <> 0 Then
		Return $iINI
	EndIf

	If $iFileExists = 0 Or $iFileGetSize = 0 Then
		$iINIData = "Version=" & $Global_Version & @LF & "SizeWin=680;490" & @LF & "Maximized=0" & @LF & "OriginalLang=None" & @LF & "TranslationLang=None" & @LF & _
		"RestoreFiles=True" & @LF & "KeepBackup=True" & @LF & "LastLine=0" & @LF & "OriginalFile=None" & @LF & "TranslationFile=None" & @LF & "OldOriginalFile=None"

		__IniWriteEx($iINI, "General", "", $iINIData)
	EndIf
	Return $iINI
EndFunc   ;==>__IsSettingsFile
#EndRegion >>>>> Setting Functions <<<<<

#Region >>>>> Size Functions <<<<<
Func __GetCurrentSize($gWindow = "")
	#cs
		Description: Get The Current Size From The Settings INI File.
		Returns: Array[2]
		[0] - Width Size [300]
		[1] - Height Size [200]
	#ce
	Local $gINI = __IsSettingsFile() ; Get Default Settings INI File.
	Return StringSplit(IniRead($gINI, "General", $gWindow, "680;490"), ";", 2)
EndFunc   ;==>__GetCurrentSize

Func __SetCurrentSize($hHandle = "", $hWindow = "")
	#cs
		Description: Set The Current Size Of DropIt Windows.
		Returns: 1
	#ce
	If $hHandle = "" Then
		Return SetError(1, 0, 0)
	EndIf
	Local $aWinGetClientSize = WinGetClientSize($hHandle)
	If @error Then
		Return SetError(1, 0, 0)
	EndIf
	If $aWinGetClientSize[0] = 0 Then
		$aWinGetClientSize[0] = 680
		$aWinGetClientSize[1] = 490
	EndIf
	Local $sINI = __IsSettingsFile() ; Get Default Settings INI File.
	__IniWriteEx($sINI, "General", $hWindow, $aWinGetClientSize[0] & ";" & $aWinGetClientSize[1])
	Return 1
EndFunc   ;==>__SetCurrentSize
#EndRegion >>>>> Size Functions <<<<<

#Region >>>>> Internal Functions <<<<<
Func __GetFileExtension($sFilePath)
	#cs
		Description: Get The File Extension.
		Returns: File Extension [txt]
	#ce
	Return StringTrimLeft(_WinAPI_PathFindExtension($sFilePath), 1)
EndFunc   ;==>__GetFileExtension

Func __GetFileNameOnly($sFilePath)
	#cs
		Description: Get The File Name Only From A File Path.
		Returns: File Name [FileName]
	#ce
	Return _WinAPI_PathStripPath(_WinAPI_PathRemoveExtension($sFilePath))
EndFunc   ;==>__GetFileNameOnly

Func __GetParentFolder($sFilePath)
	#cs
		Description: Get The Parent Folder.
		Returns: Parent Folder [C:\Program Files\Test] Or Empty String If @error
	#ce
	Return _WinAPI_PathRemoveFileSpec($sFilePath)
EndFunc   ;==>__GetParentFolder

Func __GetTranslate($sOriginal_String, $sOriginal_Language = "auto", $sTranslation_Language = "auto")
	#cs
		Description: Get Translation Of A String.
		Returns: Translated String [Hello World]
	#ce
	Local $oIE = _IECreate("http://translate.google.com/#" & $sOriginal_Language & "|" & $sTranslation_Language & "|" & $sOriginal_String, 0, 0, 1)
	Local $hResult_Destination = _IEGetObjById($oIE, "result_box")
	Local $sTranslated_String = _IEPropertyGet($hResult_Destination, "innertext")
	_IEQuit($oIE)
	Return $sTranslated_String
EndFunc   ;==>__GetTranslate

Func __IniReadSection($iFile, $iSection) ; Modified From: http://www.autoitscript.com/forum/topic/32004-iniex-functions-exceed-32kb-limit/page__view__findpost__p__229487
	#cs
		Description: Read A Section From A Standard Format INI File.
		Returns: $Array[?] - Array Contains Unlimited Number Of Items.
		[0][0] - Number Of Rows [3]

		[A][0] - Key [Example]
		[A][1] - Value [Test]
	#ce
	Local $iSize = FileGetSize($iFile) / 1024
	If $iSize <= 31 Then
		Local $iRead = IniReadSection($iFile, $iSection)
		If @error Then
			Return SetError(@error, 0, 0)
		EndIf
		If IsArray($iRead) = 0 Then
			Return SetError(-2, 0, 0)
		EndIf
		Return $iRead
	EndIf

	Local $iSplitKeyValue
	Local $iFileRead = FileRead($iFile)
	Local $iData = StringRegExp($iFileRead, "(?is)(?:^|\v)(?!;|#)\h*\[\h*\Q" & $iSection & "\E\h*\]\h*\v+(.*?)(?:\z|\v\h*\[)", 1)
	If @error Then
		Return SetError(1, 0, 0)
	EndIf

	Local $iLines = StringSplit(StringRegExpReplace($iData[0], @CRLF & "|" & @CR & "|" & @LF, @LF), @LF)
	Local $iLeft, $iAdded = 0, $iSectionReturn[$iLines[0] + 1][2]
	For $A = 1 To $iLines[0]
		$iLeft = StringLeft(StringStripWS($iLines[$A], 8), 1)
		If $iLeft == ";" Or $iLeft == "#" Then
			ContinueLoop
		EndIf

		$iSplitKeyValue = StringSplit($iLines[$A], "=")
		If $iSplitKeyValue[0] > 1 Then
			$iAdded += 1
			$iSectionReturn[$iAdded][0] = $iSplitKeyValue[1]
			For $B = 2 To $iSplitKeyValue[0]
				If $B > 2 Then
					$iSectionReturn[$iAdded][1] &= "="
				EndIf
				$iSectionReturn[$iAdded][1] &= $iSplitKeyValue[$B]
			Next
		EndIf
	Next
	ReDim $iSectionReturn[$iAdded + 1][2]
	$iSectionReturn[0][0] = $iAdded
	Return $iSectionReturn
EndFunc   ;==>__IniReadSection

Func __IniWriteEx($iFile, $iSection, $iKey = "", $iValue = "")
	#cs
		Description: Write A Key Or A Section From A Standard Format INI File With Unicode Support.
		Returns: 1
	#ce
	Local $iWrite
	If $iKey = "" Then ; Write Section.
		$iWrite = IniWriteSection($iFile, $iSection, $iValue)
	Else ; Write Key.
		$iWrite = IniWrite($iFile, $iSection, $iKey, $iValue)
	EndIf
	If $iWrite = 0 Then
		Return SetError(1, 0, 0)
	EndIf
	Return 1
EndFunc   ;==>__IniWriteEx
#EndRegion >>>>> Internal Functions <<<<<
